#version 330 core
 
layout(location=0) out vec4 vFragColor;//fragment shader output

smooth in vec2 vUV;	//input interpolated texture coordinate

//uniform
uniform sampler2D textureMap;	//the input image to blur

//constant kernel values for Gaussian smoothing
const float kernel[]=float[21] (0.000272337,  0.00089296, 0.002583865, 0.00659813,  0.014869116,
								0.029570767, 0.051898313, 0.080381679, 0.109868729, 0.132526984, 
								0.14107424,  0.132526984, 0.109868729, 0.080381679, 0.051898313, 
								0.029570767, 0.014869116, 0.00659813,  0.002583865, 0.00089296, 0.000272337);
 
void main()
{ 
	//get the inverse of texture size
	vec2 delta = 1.0/textureSize(textureMap,0);
	vec4 color = vec4(0);
	int  index = 20;
	 
	//go through all neighbors and multiply the kernel value with the obtained 
	//colour from the input image
	/*for(int i=-10;i<=10;i++) {				
		color += kernel[index--]*texture(textureMap, vUV + (vec2(i*delta.x,0)));
	}*/
	
	color+=0.000272337*texture(textureMap, vUV + (vec2(-10*delta.x,0)));
	color+=0.00089296*texture(textureMap, vUV + (vec2(-9*delta.x,0)));
	color+=0.002583865*texture(textureMap, vUV + (vec2(-8*delta.x,0)));
	color+=0.00659813*texture(textureMap, vUV + (vec2(-7*delta.x,0)));
	color+=0.014869116*texture(textureMap, vUV + (vec2(-6*delta.x,0)));
	color+=0.029570767*texture(textureMap, vUV + (vec2(-5*delta.x,0)));
	color+=0.051898313*texture(textureMap, vUV + (vec2(-4*delta.x,0)));
	color+=0.080381679*texture(textureMap, vUV + (vec2(-3*delta.x,0)));
	color+=0.109868729*texture(textureMap, vUV + (vec2(-2*delta.x,0)));
	color+=0.132526984*texture(textureMap, vUV + (vec2(-1*delta.x,0)));
	color+=0.14107424*texture(textureMap, vUV + (vec2(0*delta.x,0)));
	color+=0.132526984*texture(textureMap, vUV + (vec2(1*delta.x,0)));
	color+=0.109868729*texture(textureMap, vUV + (vec2(2*delta.x,0)));
	color+=0.080381679*texture(textureMap, vUV + (vec2(3*delta.x,0)));
	color+=0.051898313*texture(textureMap, vUV + (vec2(4*delta.x,0)));
	color+=0.029570767*texture(textureMap, vUV + (vec2(5*delta.x,0)));
	color+=0.014869116*texture(textureMap, vUV + (vec2(6*delta.x,0)));
	color+=0.00659813*texture(textureMap, vUV + (vec2(7*delta.x,0)));
	color+=0.002583865*texture(textureMap, vUV + (vec2(8*delta.x,0)));
	color+=0.00089296*texture(textureMap, vUV + (vec2(9*delta.x,0)));
	color+=0.000272337*texture(textureMap, vUV + (vec2(10*delta.x,0)));
	  
	//return the filtered colour as fragment output
    vFragColor =  vec4(color.xy,0,0);	
}